unit ClipbrdW;

interface

function PutToClipBrd(const S: WideString; ABox: boolean): boolean;
function GetFromClipBrd: WideString;
function HasBoxText: boolean;

procedure UnitInitialize;

implementation

uses Windows, Clipbrd;

//http://www.geocities.co.jp/SiliconValley-Oakland/3617/progress_2004Q2.html
//BoxIŃNbv{[hɓ\tƂ́AtH[}bgύXB
var
 CF_BOXTEXT1,  //MS݊H
 CF_BOXTEXT2  //TEditor݊
 : Word;

function PutToClipBrd(const S: WideString; ABox: boolean): boolean;
var
  i : integer;
  h: THandle;
  p: Pointer;
begin
  Result := false;
  if Length(s) = 0 then exit;
  i := Length(s) * 2 + 2;
  h := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, i);
  try
    p := GlobalLock(h);
    try
      Move(PWideChar(S)^, p^, i);
      Clipboard.Open;
      Clipboard.SetAsHandle(CF_UNICODETEXT, h);
      if ABox then begin
        Clipboard.SetAsHandle(CF_BOXTEXT1, h);
        Clipboard.SetAsHandle(CF_BOXTEXT2, h);
      end;
      Clipboard.Close;
      Result := true;
    finally
      GlobalUnlock(h);
    end;
  except
    GlobalFree(h);//ʏ͍폜Ȃ
  end;
end;

function GetFromClipBrd: WideString;
var
  h: THandle;
begin
  Result := '';
  Clipboard.Open;
  try
    h := GetClipboardData(CF_UNICODETEXT);
    if h = 0 then begin
      h := GetClipboardData(CF_TEXT);
      if h <> 0 then begin
        try
          Result := PWideChar(GlobalLock(h));
        finally
          GlobalUnlock(h);
        end;
      end;
    end else begin
      try
        Result := PWideChar(GlobalLock(h));
      finally
        GlobalUnlock(h);
      end;
    end;
  finally
    Clipboard.Close;
  end;
end;

function HasBoxText: boolean;
begin
  result := Clipboard.HasFormat(CF_BOXTEXT1) or Clipboard.HasFormat(CF_BOXTEXT2);
end;

procedure UnitInitialize;
begin
  CF_BOXTEXT1 := RegisterClipboardFormat('MSDEVColumnSelect');
  CF_BOXTEXT2 := RegisterClipboardFormat('TEditor Box Type');
end;

end.
