unit wsClass;

interface

uses Windows,Messages;

type
  TAWS=array of WChar;
  TWSL=array of Widestring;//TAWS;
type
  TWSList=class
  private
    FItems:TWSL;
    function Get(Index:integer):Widestring;
    procedure Put(Index:integer;const Item:Widestring);
    function GetCount:Integer;
  public
    constructor Create;
    Destructor Destroy;override;
    function Add(const Item:Widestring): Integer;
    procedure Delete(Index:Integer);
    procedure Insert(Index:Integer;const Item:Widestring);
    procedure Clear;
    property Count: Integer read GetCount;
    property Items[Index:integer]:Widestring read Get write Put;default;
  end;



implementation

{ TWSList }

function TWSList.Add(const Item:Widestring): Integer;
begin
  Result:=Length(FItems);
  SetLength(FItems,Result+1);
//  SetLength(FItems[Result],Length(Item));
//  CopyMemory(PWChar(FItems[Result][0]),PWChar(Item),Length(Item)*2);
  FItems[Result]:=Item;
end;

procedure TWSList.Clear;
var
  i:integer;
begin
  for i:=0 to Length(FItems)-1 do SetLength(FItems[i],0);
  SetLength(FItems,0);
end;

constructor TWSList.Create;
begin
  inherited Create;
  SetLength(FItems,0);
end;

procedure TWSList.Delete(Index: Integer);
var
  i:integer;
begin
  SetLength(FItems[Index],0);
  for i:=Index to Length(FItems)-2 do begin
    FItems[i]:=FItems[i+1];
  end;
  SetLength(FItems[Length(FItems)-1],0);
  SetLength(FItems,Length(FItems)-1);
end;

destructor TWSList.Destroy;
begin

  inherited;
end;

function TWSList.Get(Index: integer): Widestring;
begin
//  SetLength(Result,Length(FItems[Index]));
//  CopyMemory(PWChar(Result),PWChar(FItems[Index][0]),Length(FItems[Index])*2);
  Result:=FItems[Index]
end;

function TWSList.GetCount: Integer;
begin
  Result:=Length(FItems);
end;

procedure TWSList.Insert(Index: Integer; const Item: Widestring);
var
  i:integer;
begin
  SetLength(FItems,Length(FItems)+1);
  for i:=Length(FItems)-2 downto Index do FItems[i+1]:=FItems[i];
//  SetLength(FItems[Index],Length(Item));
//  CopyMemory(PWChar(FItems[Index][1]),PWChar(Item),Length(Item)*2);
  FItems[Index]:=Item;
end;

procedure TWSList.Put(Index: integer;const Item: Widestring);
begin
//  SetLength(FItems[Index],Length(Item));
//  CopyMemory(PWChar(FItems[Index][1]),PWChar(Item),Length(Item)*2);
  FItems[Index]:=Item;
end;



end.
