program Mana2;

uses
  Windows,
  Messages,
  Forms,
  WideStrUtils,
  TntForms,
  DragDropClasses in 'TNotePad\DragDropClasses.pas',
  FontUtils in 'TNotePad\FontUtils.pas',
  LineParser in 'TNotePad\LineParser.pas',
  ModeCpp in 'TNotePad\ModeCpp.pas',
  ModeCSharp in 'TNotePad\ModeCSharp.pas',
  ModeDefault in 'TNotePad\ModeDefault.pas',
  ModeDelphi in 'TNotePad\ModeDelphi.pas',
  ModeHtml in 'TNotePad\ModeHtml.pas',
  ModeJava in 'TNotePad\ModeJava.pas',
  ModeJScript in 'TNotePad\ModeJScript.pas',
  ModePerl in 'TNotePad\ModePerl.pas',
  ModePython in 'TNotePad\ModePython.pas',
  ModeRuby in 'TNotePad\ModeRuby.pas',
  ModeVBScript in 'TNotePad\ModeVBScript.pas',
  MultiByteMap in 'TNotePad\MultiByteMap.pas',
  NotePadClasses in 'TNotePad\NotePadClasses.pas',
  NotePadConsts in 'TNotePad\NotePadConsts.pas',
  NotePadMode in 'TNotePad\NotePadMode.pas',
  NotePadSearch in 'TNotePad\NotePadSearch.pas',
  NotePadString in 'TNotePad\NotePadString.pas',
  NotePadView in 'TNotePad\NotePadView.pas',
  ParserConsts in 'TNotePad\ParserConsts.pas',
  PointerList in 'TNotePad\PointerList.pas',
  StringBuffer in 'TNotePad\StringBuffer.pas',
  UnicodeWrap in 'TNotePad\UnicodeWrap.pas',
  UniControl in 'TNotePad\UniControl.pas',
  wsStream in 'Units\wsStream.pas',
  brwsfldr in 'Units\brwsfldr.pas',
  cbwatch in 'Units\cbwatch.pas',
  codedlgunit in 'Units\codedlgunit.pas',
  DM in 'Units\DM.pas',
  FixFlatPanel in 'Units\FixFlatPanel.pas',
  FixTntCombo in 'Units\FixTntCombo.pas',
  GifImage in 'Units\GifImage.pas',
  gthread in 'Units\gthread.pas',
  HKeyMacro in 'Units\HKeyMacro.pas',
  ImageLoad in 'Units\ImageLoad.pas',
  InputDialog in 'Units\InputDialog.pas',
  NotePadPrinter in 'Units\NotePadPrinter.pas',
  PLBxCtls in 'Units\PLBxCtls.pas',
  PSpeedButton in 'Units\PSpeedButton.pas',
  psvActiveScript in 'Units\psvActiveScript.pas',
  ShortCutUnit in 'Units\ShortCutUnit.pas',
  TB2Toolbar in 'Units\TB2Toolbar.pas',
  TBXStatusBars in 'Units\TBXStatusBars.pas',
  TextFileEncoding in 'Units\TextFileEncoding.pas',
  TntMenus in 'Units\TntMenus.pas',
  wNotePad in 'Units\wNotePad.pas',
  wsClass in 'Units\wsClass.pas',
  wsFileOp in 'Units\wsFileOp.pas',
  WSHModal in 'Units\WSHModal.pas',
  WSHObjects in 'Units\WSHObjects.pas',
  WSHResultUnit in 'Units\WSHResultUnit.pas',
  wsMemIni in 'Units\wsMemIni.pas',
  TKCollapsePanel in 'Units\TKCollapsePanel.pas',
  ClipbrdW in 'TNotePad\ClipbrdW.pas',
  codeconv in 'TNotePad\codeconv.pas',
  codeconvsub in 'TNotePad\codeconvsub.pas',
  UnicodeOthers in 'TNotePad\UnicodeOthers.pas',
  FixTntTabPage in 'Units\FixTntTabPage.pas',
  FixTntListView in 'Units\FixTntListView.pas',
  OnigurumaClasses in 'Units\OnigurumaClasses.pas',
  TBXOfficeXPTheme in 'Units\TBXOfficeXPTheme.pas',
  MAIN in 'Forms\MAIN.PAS' {Mana22Form: TTntForm},
  OptionDialogUnit in 'Forms\OptionDialogUnit.pas' {OptionDialog},
  grepbox in 'Forms\grepbox.pas' {GrepForm: TTntForm},
  CHILDTAB in 'Forms\CHILDTAB.pas' {ChildFrame: TTntForm},
  AboutBoxForm in 'Forms\AboutBoxForm.pas' {AboutBox},
  PrintDialogUnit in 'Forms\PrintDialogUnit.pas' {PrintDialog},
  ReplaceConfirmBox in 'Forms\ReplaceConfirmBox.pas' {ReplaceConfirmForm},
  StringsPrinterPreview in 'Forms\StringsPrinterPreview.pas' {FormStringsPrinterPreview},
  StringsPrinterProgress in 'Forms\StringsPrinterProgress.pas' {FormStringsPrinterProgress},
  wHreplfm in 'Forms\wHreplfm.pas' {FormReplace},
  wHschfm in 'Forms\wHschfm.pas' {FormSearch},
  MarkDeleteForm in 'Forms\MarkDeleteForm.pas' {MarkDeleteDlg},
  MarkJumpForm in 'Forms\MarkJumpForm.pas' {MarkJumpDlg},
  ChildPopupMenu in 'Units\ChildPopupMenu.pas',
  InputForm in 'Forms\InputForm.pas' {NumberInputForm},
  CompleteForm in 'Forms\CompleteForm.pas' {FormComplete},
  FontDialogUnit in 'Forms\FontDialogUnit.pas' {FontSelDialog},
  ModeVisualBasic in 'TNotePad\ModeVisualBasic.pas',
  ImeChangeForm in 'Forms\ImeChangeForm.pas' {ImeChangeDlg: TTntForm},
  ModeCss in 'TNotePad\ModeCss.pas',
  ModeBat in 'TNotePad\ModeBat.pas';

{$R *.res}
{$R WindowsXP.res}

var
  h: THandle;
  cds: TCopyDataStruct;
  pcData: PWChar;
  i: integer;
  s: WideString;

begin
//HeapChecker.OutputClassName := True;
//HeapChecker.DumpLeakMemory := True;
//AllocMemCountStart := true;
//  SetWindowLong(Application.Handle, GWL_EXSTYLE,
//    GetWindowLong(Application.Handle, GWL_EXSTYLE) or WS_EX_TOOLWINDOW);
  Application.Initialize;
  Application.Title := '^[܂]';
  TntApplication.Title := '^[܂]';
  h := FindWindow('TMana22Form.UnicodeClass', nil); //
  if h <> 0 then begin
    if not DebuggerPresent then begin
      s := '';
      if ParamCountW > 1 then for i := 1 to ParamCountW do begin
        s := s + ParamStrW(i);
        if i < ParamCountW then s := s + ' ';
      end;
      //t@C݂ꍇ
      //fBNg邯ǃt@CȂꍇ
      //t@Ĉݎw̏ꍇ

      if FileExistsOrCreate(s, 0) then begin
        pcData := WStrAlloc(MAX_PATH + 1);
        WStrCopy(pcData, PWChar(s));
        cds.cbData := (MAX_PATH + 1) * 2;
        cds.lpData := pcData;
        SendMessage(h, WM_COPYDATA, 0, longint(@cds));
        WStrDispose(pcData);
      end else
      for i:=1 to ParamCountW do begin
        pcData := WStrAlloc(MAX_PATH+1);
        WStrCopy(pcData, PWChar(ParamStrW(i)));
        cds.cbData := (MAX_PATH + 1) * 2;
        cds.lpData := pcData;
        SendMessage(h, WM_COPYDATA, 0, longint(@cds));
        WStrDispose(pcData);
      end;//for
      pcData := WStrAlloc(MAX_PATH + 1);
      WStrCopy(pcData, PWChar(WideString('')));
      cds.cbData := (MAX_PATH + 1) * 2;
      cds.lpData := pcData;
      SendMessage(h, WM_COPYDATA, 0, longint(@cds));
      WStrDispose(pcData);
      //DelphiAv̏ꍇ́AappOɏołB
      //SetForegroundWindow(GetWindow(H, GW_OWNER));
      SetForegroundWindow(h);
      //SetForegroundWindow(GetLastActivePopup(GetWindow(H,GW_OWNER)));
      exit;
    end;
  end;//if
  
  Application.CreateForm(TMana22Form, Mana22Form);
  Application.Run;
//jR[h
{
const
  C1 = #$AC00;
var
  s, ss: WideString;
 //s := #$AC00;//
 //s := #$AC00 + #$AC00;//~
 //s := #$AC00; s := s + #$AC00;//
 //s := C1 + C1;//~
 ss := C1;  s := ss + ss;  //
}
//߂ɂȂ
//http://www.uri.sakura.ne.jp/~cosmic/yuno/lab/
//IME̔閧
//http://hp.vector.co.jp/authors/VA015730/
//EM_ɑΉ悤
//gq擾
//L[s[głȂ
//firefoxQl
//^u{^KvH
//r[`FW̎d炷
//CN^T[`
//uKpv{^
//^umF
//sFp[T[
//AZuubN̐F
//RgubNƃRgAEg
//C̃^OWv
//s֌Wϋl߂悤
//AhDAׂ
//ul
//XNvg̓o^AV[Jbg
//GrepŃWvƂ͌nCCg𑀍삵悤
//ĕῗ͈傫Ƃǂ邩
//html&lt;&gt;F
//GetStartupInfoW
//ϊ֘A
end.

